/* $Workfile: OsaLinuxAsp.h $   $Revision: 4 $    $Modtime: 11/18/08 3:25p $  */
/*******************************************************************************

  Odin TeleSystems Inc.

  OTX Telecom Adapter Driver

  @doc internal

  @module

  @normal Copyright (C) Odin TeleSystems Inc., 2007, All Rights Reserved

*******************************************************************************/

#ifndef OSA_LINUX_ASP_H
#define OSA_LINUX_ASP_H

#ifdef DAVINCI


#ifdef __cplusplus
extern "C" {
#else
#endif


// Macros for the TxIrq and RxIrq callback functions
#define OSA_ASP_DMA_COMPLETE             0x00000001
#define OSA_ASP_DMA_ERROR                0x00000002
#define OSA_ASP_DMA_PING_BUF_READY       0x00000004
#define OSA_ASP_DMA_PONG_BUF_READY       0x00000008
#define OSA_ASP_DMA_OVER_UNDER_RUN_USER  0x00000010
#define OSA_ASP_DMA_OVER_UNDER_RUN_HW    0x00000020
#define OSA_ASP_DMA_SYNC_ERROR           0x00000040


typedef struct {
	OsaUint16 spcr2;
	OsaUint16 spcr1;
	OsaUint16 rcr2;
	OsaUint16 rcr1;
	OsaUint16 xcr2;
	OsaUint16 xcr1;
	OsaUint16 srgr2;
	OsaUint16 srgr1;
	OsaUint16 mcr2;
	OsaUint16 mcr1;
	OsaUint16 pcr2;
	OsaUint16 pcr0;
	OsaUint16 rcerc;
	OsaUint16 rcerd;
	OsaUint16 xcerc;
	OsaUint16 xcerd;
	OsaUint16 rcere;
	OsaUint16 rcerf;
	OsaUint16 xcere;
	OsaUint16 xcerf;
	OsaUint16 rcerg;
	OsaUint16 rcerh;
	OsaUint16 xcerg;
	OsaUint16 xcerh;
} OsaLinuxAspRegCfgS;


extern int OsaLinuxAspInit(int cbBufSize, void *pContext, void (*funcServeTxIrq)(unsigned long, void *), void (*funcServeRxIrq)(unsigned long, void *));

extern int OsaLinuxAspAllocBuffers(int cbBufSize);  // Can be called after OsaLinuxAspOpen() if the default buffer size needs to be changed

extern int OsaLinuxAspGetBufferPointers(char **pRxPing, char **pRxPong, char **pTxPing, char **pTxPong);

extern int OsaLinuxSetAspCfg(OsaLinuxAspRegCfgS *pRegCfg);

extern int  OsaLinuxAspOpen(void);

extern void OsaLinuxAspClose(void);

extern int OsaLinuxAspEnable(void);
extern int OsaLinuxAspDisable(void);
 
extern ssize_t OsaLinuxAspWrite(const char *buffer, size_t count);
 
extern ssize_t OsaLinuxAspRead(char *buffer, size_t count);

extern int OsaLinuxAspDbgDump(OsaUint32 nCmd);   // only for debugging

#ifdef __cplusplus
}
#endif

#endif // DAVINCI code only

#endif  // OSA_LINUX_ASP_H

